const char serverGSM[] = "3.145.117.185";
String resource = "";
const int  port = 1880;

extern String nome;
extern float consumoAgua; 
extern float consumoEnergia; 
extern float cor; 
extern float condutividade; 
extern float temperatura; 
extern float oxigenio; 
extern float cloro;

#define TINY_GSM_MODEM_SIM7600

#define SerialMon Serial
#define SerialAT Serial2

#if !defined(TINY_GSM_RX_BUFFER)
#define TINY_GSM_RX_BUFFER 650
#endif

#define TINY_GSM_DEBUG SerialMon

#define GSM_AUTOBAUD_MIN 115200
#define GSM_AUTOBAUD_MAX 115200

#define TINY_GSM_USE_GPRS true
#define TINY_GSM_USE_WIFI false

// set GSM PIN, if any
#define GSM_PIN ""

// Your GPRS credentials, if any
const char apn[]  = "claro.com.br";
const char gprsUser[] = "claro";
const char gprsPass[] = "claro";

#include <TinyGsmClient.h>
#include <ArduinoHttpClient.h>

TinyGsm modem(SerialAT);

TinyGsmClient clientGsm(modem);
HttpClient http(clientGsm, serverGSM, port);

void initGsm(){
  TinyGsmAutoBaud(SerialAT, GSM_AUTOBAUD_MIN, GSM_AUTOBAUD_MAX);
  delay(6000);

  modem.restart();

#if TINY_GSM_USE_GPRS
  // Unlock your SIM card with a PIN if needed
  if (GSM_PIN && modem.getSimStatus() != 3) { modem.simUnlock(GSM_PIN); }
#endif

  delay (500);
}

int sendData (void)
{
  //volumeTratado = millis()/1000;
  
  resource = "/pwtech?nome=" + nome + 
  "&volumeTratado=" +   String (leituraFluxo(), 3) + 
  "&consumoAgua=" +     String (consumoAgua, 3) + 
  "&consumoEnergia=" +  String (consumoEnergia, 3) + 
  "&pH=" +              String (leituraPH(), 3) + 
  "&Turbidez=" +        String (leituraTurbidez(), 3) + 
  "&Cor=" +             String (cor, 3) + 
  "&Condutividade=" +   String (condutividade, 3) + 
  "&Temperatura=" +     String (leituraTemperatura(), 3) + 
  "&Oxigenio=" +        String (oxigenio, 3) + 
  "&Cloro=" +           String (cloro, 3);

  
  if (!modem.isGprsConnected()) {modem.gprsConnect(apn, gprsUser, gprsPass);}

  SerialMon.print("Waiting for network...");
  if (!modem.waitForNetwork()) {
    SerialMon.println(" fail");
    delay(1000);
    gsmStatus = 1;
    return 1;
  }
  else {SerialMon.println(" success");}

  if (modem.isNetworkConnected()) { SerialMon.println("Network connected"); }

  SerialMon.print(F("Connecting to "));
  SerialMon.print(apn);
  if (!modem.gprsConnect(apn, gprsUser, gprsPass)) {
    SerialMon.println(" fail");
    gsmStatus = 1;
    return 1;
    delay(1000);
  }
  else {SerialMon.println(" success");}

  if (modem.isGprsConnected()) { SerialMon.println("GPRS connected"); }

  SerialMon.println ();
  SerialMon.print(F("Performing HTTP GET request... "));
  int err = http.get(resource.c_str());
  if (err != 0) {
    SerialMon.println(F("failed to connect"));
    delay(1000);
    gsmStatus = 1;
    return 1;
  }

  int status = http.responseStatusCode();
  SerialMon.print(F("Response status code: "));
  SerialMon.println(status);
  if (!status) {
    delay(1000);
  }

  String body = http.responseBody();
  SerialMon.println(F("Response:"));
  SerialMon.println(body);

  // Shutdown

  http.stop();
  SerialMon.println(F("Server disconnected"));

//  modem.gprsDisconnect();
//  SerialMon.println(F("GPRS disconnected"));
  gsmStatus = 0;
  return 0;
}

void stopGSM(){
  http.stop();
}
