String esp_ssid = "SWTech";  // Enter SSID here
String esp_password = "123456789";  //Enter Password here
extern String ssid;
extern String password;
extern String device;

byte restartFlag = 0;

/* Put IP Address details */
IPAddress local_ip  (192,168,1,1);
IPAddress gateway   (192,168,1,1);
IPAddress subnet    (255,255,255,0);
 
AsyncWebServer server(80);

const char* PARAM_INPUT_0 = "input0";
const char* PARAM_INPUT_1 = "input1";
const char* PARAM_INPUT_2 = "input2";
const char* PARAM_INPUT_3 = "input3";

//// HTML web page to handle 3 input fields (input1, input2, input3)
//const char index_html[] PROGMEM = R"rawliteral(
//<!DOCTYPE HTML><html><head>
//  <title>ESP Input Form</title>
//  <meta name="viewport" content="width=device-width, initial-scale=1">
//  </head><body>
//  <form action="/get">
//    input1: <input type="text" name="input1">
//    <input type="submit" value="Submit">
//  </form><br>
//  <form action="/get">
//    input2: <input type="text" name="input2">
//    <input type="submit" value="Submit">
//  </form><br>
//  <form action="/get">
//    input3: <input type="text" name="input3">
//    <input type="submit" value="Submit">
//  </form>
//</body></html>)rawliteral";

// HTML web page to handle 3 input fields (input1, input2, input3)
const char index_html[] PROGMEM = R"rawliteral(
<!DOCTYPE HTML><html lang="pt-BR"><head>
  <title>PWTech Settings</title>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  </head><body>

 <style>
                * {
            margin: 0;
            padding: 0;
            outline: 0;
            box-sizing: border-box;
        }
        
        form {
            text-align: center;
        }
        
        body {
            height: 100vh;
            background-color: rgb(227, 239, 244);
            color: rgb(12, 92, 117);
            font-weight: bolder;
            font-family: Montserrat, sans-serif;
        }
        
        h1 {
            background-color: rgb(12, 92, 117);
            color: white;
            height: 6vh;
            width: 100%;
            justify-content: center;
            justify-items: center;
            text-align: start;
            padding-left: 4px;
            padding-top: 1vh;
        }
        
        h2 {
            margin-bottom: 20vh;
            margin-top: 1rem;
            padding-left: 4px;
        }
        
        main {
            height: 100%;
            display: flex;
            flex-direction: column;
            justify-content: flex-start;
        }
        
        .inputs-container {
            display: flex;
            justify-content: space-between;
            width: 450px;
            height: 30px;
        }
        
        .inputs_general {
            margin: 1rem;
            display: flex;
            justify-content: center;
            align-content: center;
            justify-self: center;
        }
        
.input_form {
            border-radius: 10px;
            width: 20rem;
            border: 2px solid rgb(12, 92, 117);
        }
        
        .button_form {
            border-radius: 10px;
            background-color: rgb(12, 92, 117);
            color: white;
            height: 3rem;
            width: 8rem;
            font-size: 18px;
            box-shadow: 4px 4px rgb(8, 62, 79);
            border: 2px solid rgb(12, 92, 117);
        }
</style>

<main>
    <h1>PWTech</h1>
  <h2>Configurações IoT</h2>
  <div class="inputs_general">
  <form action="/get">

    <div class="inputs-container">
    <span>Rede:</span>
    <input type="text" name="input0" class="input_form">
    </div>
    <br>
    <br>
    <div class="inputs-container">
    <span>Senha:</span>
    <input type="text" name="input1" class="input_form">
    </div>
    <br>
    <br>
    <div class="inputs-container">
    <span>Dispositivo:</span>
    <input type="text" name="input2" class="input_form">
    </div>
    <br>
    <br>
    <br>
    <br>
    
    <input type="submit" value="Submit" class="button_form">
    <br>
  </form>
  </div>
</main>
  
</body></html>)rawliteral";

void notFound(AsyncWebServerRequest *request) {
  request->send(404, "text/plain", "Not found");
}

void serverStart (void)
{
  WiFi.mode(WIFI_AP);
  WiFi.softAP(esp_ssid.c_str(), esp_password.c_str());
  delay (2000);
  WiFi.softAPConfig(local_ip, gateway, subnet);
  delay(100);

  // Send web page with input fields to client
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/html", index_html);
  });
 
  server.on(
    "/post",
    HTTP_POST,
    [](AsyncWebServerRequest * request){},
    NULL,
    [](AsyncWebServerRequest * request, uint8_t *data, size_t len, size_t index, size_t total) {
 
      for (size_t i = 0; i < len; i++) {
        Serial.write(data[i]);
      }
 
      Serial.println();
 
      request->send (200, "text/plain", "OK");
  });
 
  // Send a GET request to <ESP_IP>/get?input1=<inputMessage>
  server.on("/get", HTTP_GET, [] (AsyncWebServerRequest *request) {
  String inputMessage[10];
  String inputParam;

    ssid      = request->getParam(PARAM_INPUT_0)->value();
    password  = request->getParam(PARAM_INPUT_1)->value();
    device    = request->getParam(PARAM_INPUT_2)->value();

Serial.println("Apos ler variaveis");
  Serial.print("ssid: ");
  Serial.println(ssid);
  Serial.print("password: ");
  Serial.println(password);
  Serial.print("device: ");
  Serial.println(device); 
    

    for (byte i = 0; i < 10; ++i)
    {
      Serial.print ("Input[" + String(i) + "] -> ");
      Serial.println (inputMessage[i]);
    }
    Serial.println ();
    restartFlag = 1;
    
    request->send(200, "text/html", "HTTP GET request sent to your ESP on input field (" 
                                     + inputParam + ") with value: " + inputMessage[0] +
                                     "<br><a href=\"/\">Return to Home Page</a>");

    String settings = "";

    settings += ssid + "\r\n";
    settings += password + "\r\n";
    settings += device + "\r\n";

  Serial.println("Apos montar variavel pra salvar");
  Serial.print("ssid: ");
  Serial.println(ssid);
  Serial.print("password: ");
  Serial.println(password);
  Serial.print("device: ");
  Serial.println(device); 

  delay(500);

    writeFile   (SPIFFS, "/set.txt", settings.c_str());
    
  settingsRead();

  delay(100);

      Serial.println("resetando");
      ESP.restart();
  
    
  });
  server.onNotFound(notFound);
  server.begin();
  
  Serial.println ("SERVER STARTED");

  Serial.println("Apos salvar na memoria");
  Serial.print("ssid: ");
  Serial.println(ssid);
  Serial.print("password: ");
  Serial.println(password);
  Serial.print("device: ");
  Serial.println(device);
}

void serverStop (void)
{
  server.end();

  Serial.println ("SERVER STOPED");
}



void disableWiFi(void)
{
//  adc_power_off();
  WiFi.disconnect(true);  // Disconnect from the network
  WiFi.mode(WIFI_OFF);    // Switch WiFi off
}
