unsigned int wifiCount = 0;

#define AWS_IOT_PUBLISH_TOPIC   "pwtech"
#define AWS_IOT_SUBSCRIBE_TOPIC "pwtech"

WiFiClientSecure net = WiFiClientSecure();
PubSubClient client(net);

int connectAWS()
{
//  const char WIFI_SSID[] = "ssid";               //change this
//  const char WIFI_PASSWORD[] = "password";    
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid.c_str(), password.c_str());

  Serial.println("Connecting to Wi-Fi");

  while (WiFi.status() != WL_CONNECTED)
  {
    delay(500);
    Serial.print(".");
    wifiCount ++;
    if (wifiCount >= 20){
      wifiStatus = 1;
      //disableWiFi();
      delay(200);
      serverStart();
      return 1;
    }
  }

  Serial.print("Connected to Wi-Fi ");
  Serial.println(ssid);

  // Configure WiFiClientSecure to use the AWS IoT device credentials
  net.setCACert(AWS_CERT_CA);
  net.setCertificate(AWS_CERT_CRT);
  net.setPrivateKey(AWS_CERT_PRIVATE);

  // Connect to the MQTT broker on the AWS endpoint we defined earlier
  client.setServer(AWS_IOT_ENDPOINT, 8883);

  // Create a message handler
  client.setCallback(messageHandler);

  Serial.println("Connecting to AWS IOT");

  while (!client.connect(THINGNAME))
  {
    Serial.print(".");
    delay(100);
    Serial.println(client.connect(THINGNAME));
  }

  if (!client.connected())
  {
    Serial.println("AWS IoT Timeout!");
    wifiStatus = 1;
    return 1;
  }

  // Subscribe to a topic
  client.subscribe(AWS_IOT_SUBSCRIBE_TOPIC);

  Serial.println("AWS IoT Connected!");
  wifiStatus = 0;
  return 0;
}

void publishMessage()
{
  StaticJsonDocument<1000> doc;
  doc["nome"] = "testeSenai6";
  doc["volumeTratado"] = leituraFluxo();
  doc["consumoAgua"] = 0;
  doc["consumoEnergia"] = 0;
  doc["pH"] = leituraPH();
  doc["Turbidez"] = leituraTurbidez();
  doc["Cor"] = 0;
  doc["Condutividade"] = 0;
  doc["Temperatura"] = leituraTemperatura();
  doc["Oxigenio"] = 0;
  doc["Cloro"] = 0;
  char jsonBuffer[1024];
  serializeJson(doc, jsonBuffer); // print to client

  client.publish(AWS_IOT_PUBLISH_TOPIC, jsonBuffer);
  Serial.println(jsonBuffer);
}

void messageHandler(char* topic, byte* payload, unsigned int length)
{
  Serial.print("incoming: ");
  Serial.println(topic);

  StaticJsonDocument<200> doc;
  deserializeJson(doc, payload);
  const char* message = doc["message"];
  Serial.println(message);
}

void loopWifi(){
    publishMessage();
    client.loop();
}
